package FromDualMySQLmyisam;

#
# Copyright (C) 2010, 2011, 2012 FromDual GmbH
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.
# If not, see <http://www.gnu.org/licenses/>.
#

use strict;
use warnings;

use FromDualMySQLagent ':stooges';
use POSIX qw(floor);

sub processMyisamInformation
{
  if ( $main::gParameter{'Debug'} >= INFO ) { &FromDualMySQLagent::log($main::gParameter{'LogFile'}, INFO, '    ' . (caller(0))[3]); }

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
    'key_buffer_size'
  , 'key_buffer_blocks'
  , 'key_cache_block_size'
  );

  my @aGlobalStatusToSend = (
    'Key_blocks_not_flushed'
  , 'Key_blocks_unused'
  , 'Key_blocks_not_flushed'
  , 'Key_blocks_unused'
  , 'Key_blocks_used'
  , 'Key_blocks_warm'
  , 'Key_read_requests'
  , 'Key_reads'
  , 'Key_write_requests'
  , 'Key_writes'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(%main::gParameter);

  if ( ! defined($dbh) ) {
    if ( $main::gParameter{'Debug'} >= ERR ) { &FromDualMySQLagent::log($main::gParameter{'LogFile'}, DBG, '    Database connection failed.'); }
    return -1;
  }

  if ( ! defined($dbh) ) {
    return -1;
  }

  &FromDualMySQLagent::getGlobalVariables($dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus($dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection($dbh);

  # Do some post calculations

  $hGlobalVariables{'key_buffer_blocks'} = $hGlobalVariables{'key_cache_block_size'} == 0 ? 0 : floor($hGlobalVariables{'key_buffer_size'} / $hGlobalVariables{'key_cache_block_size'});

  &FromDualMySQLagent::sendData(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::sendData(\%hGlobalStatus, \@aGlobalStatusToSend);
}

1;
__END__

